summaryrefslogtreecommitdiff
path: root/git-shell-commands/setdesc
diff options
context:
space:
mode:
Diffstat (limited to 'git-shell-commands/setdesc')
-rwxr-xr-xgit-shell-commands/setdesc37
1 files changed, 37 insertions, 0 deletions
diff --git a/git-shell-commands/setdesc b/git-shell-commands/setdesc
new file mode 100755
index 0000000..651b170
--- /dev/null
+++ b/git-shell-commands/setdesc
@@ -0,0 +1,37 @@
+#!/bin/sh
+# Copyright (C) 2024 dwlr <dweller@cabin.digital>
+#
+# BSD 3-Clause License (BSD-3-Clause)
+# See LICENSE for details
+
+set -e
+
+#FIXME: this is wide open for exploits by using crafted paths like ../../../etc/passwd or something
+# But we should be okay since this is behind ssh, right? r- right..?
+
+
+PREFIX="$HOME/repos"
+
+if [ $# -lt 2 ]; then
+ echo "Usage: $(basename $0) <repo name> <description>"
+ exit 1;
+fi
+
+case "$1" in
+ *.git) reponame="$1" ;;
+ *) reponame="$1.git" ;;
+esac
+
+netname=$(echo "$PREFIX/$reponame" | sed "s|$HOME|:|")
+reponame="$PREFIX/$reponame"
+
+
+if [ -e "$reponame" ];
+then
+ cd "$reponame"
+ shift
+ echo "$@" > description
+else
+ echo "$netname doesn't exists!"
+ exit 1
+fi